import java.util.List;
import java.util.LinkedList;

public class Alphabet extends KnowledgeSource {

    private int _current = 0;

    private int _lastWordLength = 0;

    private boolean _spaceGenerated = false;

    private List _letters = new LinkedList();

    public Alphabet() {
        for (int i = 0; i < 26; i++) {
            char c = (char)('a' + i);
            _letters.add(new Letter(c));
        }
    }

    public Letter nextLetter() {
        if (_current == 26) {
            _current = 0;
        }
        return (Letter)_letters.get(_current++);
    }

    public void reset() {
        _current = 0;
        _spaceGenerated = false;
    }

    public Bid bidOn(Message m) {

        int currentWordLength = m.lengthOfWord();

        if (_lastWordLength != currentWordLength) {
            _lastWordLength = currentWordLength;
            reset();
        }

        if (currentWordLength == 0) {
            return new Bid(10, nextLetter());
        } else if (!_spaceGenerated) {
            _spaceGenerated = true;
            return new Bid(10, new Letter(' '));
        } else {
            return new Bid(10, nextLetter());
        }
    }

}
